"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const util_1 = require("./util");
require("should");
index_1.amqpManager.setConnectionURI("amqp://localhost");
describe("Events for events", function () {
    beforeEach(function (done) {
        index_1.amqpManager.reconnect(function () {
            done();
        });
    });
    it("listener to all events should catch event", function (done) {
        this.timeout(15e3);
        const eventEmitter = new index_1.amqpManager.events('test-events');
        const dataReceived = [];
        eventEmitter.on('test:event', (data) => __awaiter(this, void 0, void 0, function* () {
            dataReceived.push(data);
            yield util_1.wait(3000);
        }), () => __awaiter(this, void 0, void 0, function* () {
            var event = index_1.amqpManager.createEvent({ exchange: 'test', topic: 'event' });
            event.send({ test: 'test' });
            yield util_1.wait(1000);
            console.log(dataReceived);
            eventEmitter.nowProcessingEvents.size.should.equal(1);
            yield util_1.wait(3000);
            eventEmitter.nowProcessingEvents.size.should.equal(0);
            done();
        }));
    });
});
//# sourceMappingURL=event_events.js.map