"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const util_1 = require("./util");
require("should");
index_1.amqpManager.setConnectionURI("amqp://localhost");
describe("Events remove listener", function () {
    beforeEach(function (done) {
        index_1.amqpManager.reconnect(function () {
            done();
        });
    });
    it("after removing listener events should not be passed to listener", function (done) {
        this.timeout(15e3);
        const eventEmitter = new index_1.amqpManager.events('test-events3');
        const dataReceived = [];
        const listener = (data) => __awaiter(this, void 0, void 0, function* () {
            dataReceived.push(data);
        });
        eventEmitter.on('test-remove-listener:event', listener, () => __awaiter(this, void 0, void 0, function* () {
            var event = index_1.amqpManager.createEvent({ exchange: 'test-remove-listener', topic: 'event' });
            event.send({ test: 'test' });
            yield util_1.wait(500);
            dataReceived.length.should.equal(1);
            eventEmitter.removeListener('test-remove-listener:event', listener);
            var event = index_1.amqpManager.createEvent({ exchange: 'test-remove-listener', topic: 'event' });
            event.send({ test: 'test' });
            yield util_1.wait(500);
            dataReceived.length.should.equal(1);
            done();
        }));
    });
});
//# sourceMappingURL=events_removelistener.js.map