"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const should = require("should");
var taskManager = index_1.amqpManager.tasks;
const util_1 = require("./util");
index_1.amqpManager.setConnectionURI("amqp://localhost");
describe("Tasks events", () => {
    before((done) => {
        taskManager.service = "amqpTest";
        taskManager.purgeQueue('events-for-tasks', done);
    });
    it("should produce task and consume it", function (done) {
        this.timeout(15e3);
        const newTask = taskManager.createTask('events-for-tasks', { title: "test", data: { value: 1 } });
        newTask.start(() => __awaiter(this, void 0, void 0, function* () {
            should.exists(newTask.uuid);
            taskManager.processTask('events-for-tasks', (task, doneTask) => {
                setTimeout(() => {
                    doneTask();
                }, 3000);
            });
            yield util_1.wait(1e3);
            taskManager.nowProcessingTasks.size.should.equal(1);
            yield util_1.wait(3e3);
            taskManager.nowProcessingTasks.size.should.equal(0);
            done();
        }));
    });
});
//# sourceMappingURL=tasks_events.js.map