"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
var taskManager = index_1.amqpManager.tasks;
const util_1 = require("./util");
index_1.amqpManager.setConnectionURI("amqp://localhost");
describe("Finalize tasks", () => {
    before((done) => {
        taskManager.service = "amqpTest";
        taskManager.purgeQueue('finalize-tasks', done);
    });
    it("should not receive task after finalization", function (done) {
        return __awaiter(this, void 0, void 0, function* () {
            this.timeout(15e3);
            let receivedTasks = 0;
            taskManager.processTask('finalize-tasks', (task, doneTask) => {
                receivedTasks++;
                doneTask();
            });
            const newTask = taskManager.createTask('finalize-tasks', { title: "test", data: { value: 1 } });
            newTask.start();
            yield util_1.wait(500);
            receivedTasks.should.equal(1);
            index_1.amqpManager.finalize();
            taskManager.createTask('finalize-tasks', { title: "test", data: { value: 1 } }).start();
            yield util_1.wait(500);
            receivedTasks.should.equal(1);
            done();
        });
    });
});
//# sourceMappingURL=tasks_finalize.js.map